/* Copyright (C) 2016 Centro de Computacao Cientifica e Software Livre
 * Departamento de Informatica - Universidade Federal do Parana - C3SL/UFPR
 *
 * This file is part of simmc-agent
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
 * USA.
 */

#include <agent/linux/get_machine_type.h>

std::string get_machine_type() {
    struct addrinfo hints, *info, *p;
    int gai_result;

    char hostname[1024];
    hostname[1023] = '\0';
    gethostname(hostname, 1023);

    memset(&hints, 0, sizeof(hints));
    hints.ai_family = AF_UNSPEC; /*either IPV4 or IPV6*/
    hints.ai_socktype = SOCK_STREAM;
    hints.ai_flags = AI_CANONNAME;

    gai_result = getaddrinfo(hostname, "http", &hints, &info);

    if (gai_result) {
        std::string key("getaddrinfo: ");
        std::string error(gai_strerror(gai_result));
        throw key + error;
    }

    for (p = info; p; p = p->ai_next) {
        if (!p->ai_canonname) {
            continue;
        }
        if (!strcmp(p->ai_canonname, "server.telecentro.net")) {;
            freeaddrinfo(info);
            return "server";
        }
    }

    freeaddrinfo(info);

    return "client";
}
